#!/bin/bash

# mapWOC
#
# Description: Invoke rsync with parameters to pull hcs of a node.
#
# Copyright:
# Copyright (C) 2011 Bundesamt für Sicherheit in der Informationstechnik
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2,
# or, at your option, any later version as published by the Free
# Software Foundation
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.

# pull_node_hcs.sh <node_address> <path_to_key> <node_hcs_dir>

usage()
{
  echo 'Invoke pull_node_results.sh <node_address> <node-sync-path> <path_to_key> <node_results_dir>'
}

if [ $# -ne 4 ] ; then
  usage
  exit 1
fi

NODE_ADDRESS=$1
SYNC_PATH=$2
PATH_TO_KEY=$3
NODE_RESULTS_DIR=$4
# --remove-source-files
rsync -aqz -e "ssh -oKbdInteractiveAuthentication=no \
                   -oPasswordAuthentication=no \
                   -oNumberOfPasswordPrompts=0 -i $PATH_TO_KEY" \
                   --remove-source-files \
                    $NODE_ADDRESS:$SYNC_PATH/results/ $NODE_RESULTS_DIR


