import logging

from pylons import request, response, session, tmpl_context as c, url
from pylons.controllers.util import abort, redirect

import formencode

from mapwocgui.lib.base import BaseController, render

from mapwoc.lib.redirectorvisit import RedirectorVisit
import mapwocgui.model.masterproxy as master
import mapwocgui.model.redirectorproxy as redirector

log = logging.getLogger(__name__)

class RedirectorController(BaseController):

    def index(self):
        c.redirectorproxy_state = redirector.get_state()
        c.redirectorproxy_last_urls = redirector.get_n_last_urls(3)
        c.redirectorproxy_next_urls = redirector.get_n_next_urls(3)
        c.redirectorproxy_nrremaining = redirector.get_nr_remaining_urls()
        c.redirectorproxy_percentage = redirector.get_percentage()
        c.redirectorversion = redirector.get_version()
        return render('redirector/index_redirector.mako')

    # TODO redirect to index.
    def restartwithlist(self):
        c.r = request.params.get('urls')
        redirector.feed_new_urls(c.r)
        c.redirectorproxy_next_urls = redirector.get_n_next_urls(3)
        c.redirectorproxy_last_urls = redirector.get_n_last_urls(30)
        c.redirectorproxy_nrremaining = redirector.get_nr_remaining_urls()
        # Newline separated url list
        # pylons.controllers.util.redirect_to(conroller='redirector',action='index')
        return render('redirector/index_redirector.mako')

    def last_urls(self, id):
        # TODO id shall be positive
        c.last_urls = redirector.get_n_last_urls(id)
        c.num_urls = id
        return render('redirector/last_urls_redirector.mako')
