import socket
import json

from mapwoc.lib.mapwoc_json import mapwoc_from_json_hook as json_decode
from mapwoc.lib.redirectorvisit import RedirectorVisit

def __ask_for_string_response(question):
    """Connect to redirectorctrlserver, send a string and
       receive and return max 1024.
    """

    # TODO lessen assumption.
    HOST, PORT = "localhost", 8228

    try:
        # Create a socket (SOCK_STREAM means a TCP socket)
        sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)

        # Connect to server and send data
        sock.connect((HOST, PORT))
        sock.send(question)

        # TODO handle all the odds of sockets, timeouts, exceptions, etc
        # TODO lessen assumption about amount of data transmitted

        # Receive data from the server and shut down
        received = sock.recv(1024)
        sock.close()
    except socket.error, msg:
        #received = msg
        print "Exception: "
        print type(msg)
        print msg
        received = "Connection Error: " + str(msg)

    return received
    
def get_state():
    """Connects to RedirectorCtrl and queries its state."""
    return __ask_for_string_response("state")

def get_last_urls():
    """Connects to RedirectorCtrl and queries list of last served urls."""
    return __ask_for_string_response("last").split("\n")

def get_next_urls():
    """Connects to RedirectorCtrl and queries list of next served urls."""
    return __ask_for_string_response("next").split("\n")

def get_n_next_urls(n=5):
    """Connects to RedirectorCtrl and queries list of next served urls."""
    return __ask_for_string_response("next " + str(n)).split("\n")

def get_n_last_urls(n=5):
    """Connects to RedirectorCtrl and queries list of last served urls."""
    answer = __ask_for_string_response("last " + str(n))
    return json.loads(answer, object_hook=json_decode)

def feed_new_urls(urls):
    """Connects to RedirectorCtrl and pushes a new url mapping."""
    return __ask_for_string_response("urllist\n" + urls)

def get_nr_remaining_urls():
    """Connects to RedirectorCtrl and asks for number of remaining urls
       (in sample mode).
    """
    return __ask_for_string_response("nrremaining")

def get_percentage():
    """Connects to redirector and asks for percentage (done)."""
    return __ask_for_string_response("percentage")

def get_version():
    """Connects to redirector and asks for its version."""
    return __ask_for_string_response("version") 
